

/* bugs:
   - if FF is default browser, launching from embedded player opens 2,3 windows(???)
   - if fetching a new page due to next/prev/goto, the transition will play before
    requestVideoList() returns
 */

/*
   <author>youtuberocks</author>
   <id>k0gEeue2sLk</id> <!-- this ID can be used with youtube.videos.get_details -->
   <title>My First Motion Picture</title>
   <length_seconds>16</length_seconds> <!-- length of video -->
   <rating_avg>3.75</rating_avg>
   <rating_count>10</rating_count>
   <description>This is the video description shown on the YouTube site.</description>
   <view_count>170</view_count>
   <upload_time>1121398533</upload_time> <!-- UNIX-style time, seconds since 1/1/1970 -->
   <comment_count>1</comment_count> <!-- numbers of comments this video has -->
   <tags>feature film documentary</tags>
   <url>http://www.youtube.com/watch?v=k04Eeue24Lk</url>
   <thumbnail_url>http://static.youtube.com/get_still?video_id=k04Eeue24Lk</thumbnail_url>
   <embed_status>ok</embed_status>
 */


function YouTubeVideo(vidNode)
{

    this.author = vidNode.selectSingleNode("author").text;
    this.id = vidNode.selectSingleNode("id").text;
    this.title = vidNode.selectSingleNode("title").text;
    this.length_seconds = vidNode.selectSingleNode("length_seconds").text;
    this.rating_avg = vidNode.selectSingleNode("rating_avg").text;
    this.rating_count = vidNode.selectSingleNode("rating_count").text;
    this.description = vidNode.selectSingleNode("description").text;
    this.view_count = vidNode.selectSingleNode("view_count").text;
    this.upload_time = vidNode.selectSingleNode("upload_time").text;
    this.comment_count = vidNode.selectSingleNode("comment_count").text;
    this.tags = vidNode.selectSingleNode("tags").text;
    this.url = vidNode.selectSingleNode("url").text;
    this.thumbnail_url = vidNode.selectSingleNode("thumbnail_url").text;
    /*
    try {
        this.embed_status = vidNode.selectSingleNode("embed_status").text;
    } catch (e) {
        this.embed_status = "ok";
    }
    */
}

function checkVersion()
{
    var url = "http://nanotube.gadget.googlepages.com/gadget.xml";
    requestLatestVersion(url, versionPrompt, errorPrompt);
}



function init()
{
    
    currentpg = 1;
    
    prefPerPage = 10;  // keep this high to avoid transition bug
    
    prefMethodName = System.Gadget.Settings.read("prefMethodName");
    prefMethodParamCategory = System.Gadget.Settings.read("prefMethodParamCategory");
    prefMethodParamTimerange = System.Gadget.Settings.read("prefMethodParamTimerange");
    prefMethodParamUser = System.Gadget.Settings.read("prefMethodParamUser");
    prefMethodParamTags = System.Gadget.Settings.read("prefMethodParamTags");
    prefThumbnailDelay = parseInt(System.Gadget.Settings.read("prefThumbnailDelay"));
    prefAutoplay = System.Gadget.Settings.read("prefAutoplay");
    
    if (prefThumbnailDelay == 0)
    {
        prefThumbnailDelay = -1;
    }
    if (prefAutoplay == "")
    {
        prefAutoplay = "off";
    }
    
    prefAutostopDelay = 20;   
    
    prefAutostop = prefAutoplay == "on" ? true : false;
    
    requestVideoList(0);
    currentidx = 0;
    // divThumbnail.onclick = playEmbedInContent;
    // divLayer.onmousedown = layerMousedownHandler;
    // divNavbar.onclick = navbarClickHandler;
    divNext.onclick = nextClickHandler;
    divPrev.onclick = prevClickHandler;
    divDetails.onclick = detailsClickHandler;
    divZoom.onclick = zoomClickHandler;
    divVideoNumber.onclick = numberClickHandler;
    System.Gadget.settingsUI = "settings.htm";
    System.Gadget.onSettingsClosed = settingsClosed;

}

function versionPrompt(latest)
{
    var current = parseFloat(System.Gadget.version);
    if (latest > current) 
    {
        divVersionPrompt.style.visibility = "visible";
        divVersionPromptContent.innerText = "A new version of the gadget is available!";
        ButtonVersionPromptClose.onclick = function() { divVersionPrompt.style.visibility = "hidden"; };
    }
}

function errorPrompt(e)
{

    divErrorPrompt.style.visibility = "visible";
    divErrorPromptContent.innerText = (e == null) ? "Unknown error" : e;
    ButtonErrorPromptClose.onclick = function() { divErrorPrompt.style.visibility = "hidden"; };

}

function settingsClosed(event)
{
    if (event.closeAction == event.Action.commit)
    {
        var refresh = true;
        
        var lastprefMethodName = prefMethodName;
        var lastprefMethodParamCategory = prefMethodParamCategory;
        var lastprefMethodParamTimerange = prefMethodParamTimerange;
        var lastprefMethodParamUser = prefMethodParamUser;
        var lastprefMethodParamTags = prefMethodParamTags;
        var lastprefThumbnailDelay = prefThumbnailDelay;
        var lastprefAutoplay = prefAutoplay;

        prefMethodName = System.Gadget.Settings.read("prefMethodName");
        prefMethodParamCategory = System.Gadget.Settings.read("prefMethodParamCategory");
        prefMethodParamTimerange = System.Gadget.Settings.read("prefMethodParamTimerange");
        prefMethodParamUser = System.Gadget.Settings.read("prefMethodParamUser");
        prefMethodParamTags = System.Gadget.Settings.read("prefMethodParamTags");
        prefThumbnailDelay = parseInt(System.Gadget.Settings.read("prefThumbnailDelay"));
        prefAutoplay = System.Gadget.Settings.read("prefAutoplay");    
        prefAutostop = prefAutoplay == "on" ? true : false;
        
        
        if (lastprefMethodName == prefMethodName)
        {
            if (((prefMethodName == "youtube.users.list_favorite_videos") 
                    && (prefMethodParamUser == lastprefMethodParamUser))
                ||
                ((prefMethodName == "youtube.videos.list_popular")
                    && (prefMethodParamTimerange == lastprefMethodParamTimerange))
                ||
                ((prefMethodName == "youtube.videos.list_by_category_and_tag")
                    && (prefMethodParamCategory == lastprefMethodParamCategory)
                    && (prefMethodParamTags == lastprefMethodParamTags))
                ||
                ((prefMethodName == "youtube.videos.list_by_tag")
                    && (prefMethodParamTags == lastprefMethodParamTags))
                ||
                (prefMethodName == "youtube.videos.list_featured"))
            {
                refresh = false;
            }
        }  
        
        if (refresh) 
        {
            requestVideoList(0);
            currentpg = 1;
        }
        else
        {
            // if not refreshing, then set up timer if required 
            // todo
            /*
            if (prefAutoplay == "on")
                setAutostopTimer(parseInt(v.length_seconds)); 
                */
        }        
    }
}

// index_init: specify how to initialize the currentidx var
//      0: 0 (start)
//      -1: end
//      >0: vidnum to vidarray index conversion
function requestVideoList(index_init)
{
    
    var dev_id = "61eBSS1YmDU"; // + "bug";
    var paramstring = "";           

/*
        <option value="youtube.videos.list_popular">Popular</option>
        <option value="youtube.users.list_favorite_videos">User Favourites</option>
        <option value="youtube.videos.list_by_category_and_tag">Category and Tags</option>
        <option value="youtube.videos.list_by_tag">Tags</option>
 */
    per_page = 0;
    if (prefMethodName == "")
    {
        prefMethodName = "youtube.videos.list_featured";
    }
    if (prefMethodName == "youtube.videos.list_featured")
    {
        
    }
    else if (prefMethodName == "youtube.users.list_favorite_videos")
    {
        per_page = -1;  // api limitation, check youtube.com/dev for updates
        paramstring = "&user=" + prefMethodParamUser;
    }
    else if (prefMethodName == "youtube.videos.list_popular")
    {
        paramstring = "&time_range=" + prefMethodParamTimerange;
    }
    else if (prefMethodName == "youtube.videos.list_by_category_and_tag")
    {
        per_page = prefPerPage;
        paramstring = "&category_id=" + prefMethodParamCategory + "&tag=" + prefMethodParamTags  + "&page=" + currentpg + "&per_page="  + per_page;
    }
    else if (prefMethodName == "youtube.videos.list_by_tag")
    {
        per_page = prefPerPage;
        paramstring = "&tag=" + prefMethodParamTags + "&page=" + currentpg + "&per_page="  + per_page;
    }

    var url = "http://www.youtube.com/api2_rest?method=" + prefMethodName + "&dev_id=" + dev_id + paramstring;

    // System.Debug.outputString(url);
    
    // divNoVideo.innerText = paramstring;

    xmlhttp = new XMLHttpRequest();
    xmlhttp.open('GET', url, true);
    xmlhttp.send(null);

    xmlhttp.onreadystatechange = function() {	
        if (xmlhttp.readyState == 4)
        {
            if (xmlhttp.status == 200) 
            {
                // do something with the results
                // document.getElementById("gadgetContent").innerText = xmlhttp.responseText;
                var xmlDoc = new ActiveXObject("Msxml2.DOMDocument.3.0");
                xmlDoc.async = false;
                xmlDoc.loadXML(xmlhttp.responseText);
                if (xmlDoc.parseError.errorCode != 0) 
                {
                    // do error reporting;
                    errorPrompt("XML Error.  Code=" + xmlDoc.parseError.errorCode);	   
                } 
                else 
                {	
                    buildVideolist(xmlDoc, index_init);
                    showThumbnail();
                }
            }
            else
            {
                errorPrompt("Connection Error.  Code=" + xmlhttp.status);
            }
        }
    }
}

function buildVideolist(xmlDoc, index_init)
{
    try {
        xmlDoc.setProperty("SelectionNamespaces", "xmlns:xsl='http://www.w3.org/1999/XSL/Transform'");
        xmlDoc.setProperty("SelectionLanguage", "XPath");
        vidtotal = parseInt(xmlDoc.documentElement.selectSingleNode("video_list/total").text);
        vidarray = new Array();
        
        var objNodeList = xmlDoc.documentElement.selectNodes("video_list/video");
        var i;
        
        for (i = 0; i < objNodeList.length; i++)
        {
            var v_obj = new YouTubeVideo(objNodeList.item(i));
            vidarray.push (v_obj);
        }

        // bug: youtube doesn't serve >1000 for api calls, so cap it at 1000
        if (vidtotal >= 1000)
            vidtotal = 1000;        
        
        // for some methods, the video_list/total returned is not accurate;
        // e.g. user favourites returns 10 when there are < 10 videos
        // workaround for user favourites bug: vidtotal < video nodes returned
        if (per_page < 0)
        {
            vidtotal = vidarray.length;
            per_page = vidarray.length;
            if (vidtotal == 0)
            {
                throw ("No Videos");
            }
        }
        else
        {
            // per_page is set to 0 if the method call doesn't take page parameters
            per_page = (per_page == 0) ? vidtotal : per_page;
        } 
        currentidx = (index_init <= 0)  ? ((index_init == 0) ? 0 : vidarray.length - 1)
                                        : index_init;
                                        
    } catch (e) {
        
        currentidx = 0;
        vidtotal = 0;
        per_page = 0;
        currentpg = 1;
        vidarray = new Array();
        
        errorPrompt("No videos found.");
        // errorPrompt(e.name + ":" + e.message);
        // divNoVideo.innerText += xmlDoc.xml;
    }
}

function convertSecondsToClock(s)
{
    var seconds = s % 60 < 10 ? "0" + s % 60 : s % 60;
    var minutes = Math.floor(s / 60) < 10 ? "0" + Math.floor(s / 60) : Math.floor(s / 60); 
    return minutes + ":" + seconds ;
}

function showThumbnail(noplayOverride)
{
    
    divLayer.style.visibility = "hidden";
    divEmbedded.innerHTML = "";
    divEmbedded.style.visibility = "hidden";

   // do this first, in case video not found
    showVideoNumber();
    
    var str = "";
    var v = vidarray[currentidx];
    
    if (v == null)
    {
        currentidx = 0;
        divNoVideo.style.visibility = "visible";
        return;
    }
    
    divNoVideo.style.visibility = "hidden";
    
    var width = parseInt(document.styleSheets[0].rules[2].style.width);
    var height = parseInt(document.styleSheets[0].rules[2].style.height);

    str = str + "<img src=\"" + v.thumbnail_url + '" width=' + width + ' height=' + height + '/>';

    document.getElementById("divTitle").innerHTML = '<marquee scrollAmount=4 title="' 
        + v.title + '"><a href="' + v.url + '"/>' + v.title + '</a></marquee>' ;

    divThumbnail.innerHTML = str;

    
    divLayer.onclick = playEmbedInContent;
    
    divThumbnail.onmouseenter = function() {  divLayer.style.visibility = "visible"; };
    divLayer.onmouseleave = function() {  divLayer.style.visibility = "hidden"; };
    
    
    showLength();
    showRating();
    
    if (System.Gadget.Flyout.show == true) 
    {
        if (System.Gadget.Flyout.document.getElementById("divDetailsFlyout") != null)
        {
            updateDetailsFlyout();
        }
        else 
        {
            // System.Gadget.Flyout.onhide = function() { };
            // System.Gadget.Flyout.show = false;
        }
    }


    if (tmr != null)
        clearTimeout(tmr);
    if (prefThumbnailDelay > 0)
    {
        tmr = setTimeout(nextClickHandler, 1000 * prefThumbnailDelay); 
    }
    
    if (prefAutoplay == "on" && (noplayOverride != true))
    {
        if ((System.Gadget.Flyout.show == true) 
            &&(System.Gadget.Flyout.document.getElementById("divZoomFlyout") != null))
        {
            showZoomFlyout();
        }
        else    
            playEmbedInContent();
    }
}
function showVideoNumber()
{
    var totalindex = (currentpg - 1) * per_page + currentidx + 1;
    if (vidtotal != 0)
    {
        divVideoNumber.innerText = totalindex + "/" + vidtotal; // + ":" + currentidx + ":" + currentpg + ":" + vidarray.length;
    }
    else
    {
        divVideoNumber.innerText = "0/0";
    }
}
function showLength()
{
    divLength.innerText = convertSecondsToClock(vidarray[currentidx].length_seconds);
}

function showRating()
{
    var baseurl = "bullet_star_grey.png"; 
    var colorurl = "bullet_star_red.png"; 
    var imgurl;

    var rating = parseInt(vidarray[currentidx].rating_avg);
    divRating.innerHTML = "";
    for (var i = 0; i < 5; i++)
    {
        if (rating > i)
            imgurl = colorurl;
        else
            imgurl = baseurl;

        divRating.innerHTML += '<img src="' + imgurl 
            + '" alt="' + vidarray[currentidx].rating_avg + '">';
    }
}

function titleClickHandler()
{
    return true;
}

function nextClickHandler()
{
    if (vidtotal == 0)
    {
        return;
    }
    divContent.filters[1].apply();
    currentidx += 1;
    if (currentidx == vidarray.length)
    {
        if (vidarray.length == vidtotal) 
        {
            // only 1 page, just wrap around, no fetching
            currentidx = 0;
            showThumbnail();
        }
        else 
        {
            // are there more pages?
            // currentpg is 1-based, currentidx is 0-based
            var i = (currentpg - 1) * per_page + currentidx;  
            if (i == vidtotal)
            {
                // no more, wrap around
                currentpg = 1;
            }
            
            else 
            {
                // fetch new set of pages
                currentpg += 1;
            }
            
            requestVideoList(0);
        }        
    }
                
    // currentidx = (currentidx + 1) % vidarray.length;
    else 
    {
        showThumbnail();
    }
    divContent.filters[1].play();
}

function prevClickHandler()
{
    if (vidtotal == 0)
    {
        return;
    }
    divContent.filters[0].apply();
    currentidx -= 1;
    if (currentidx < 0)
    {
        if ((currentpg == 1) && (per_page == vidtotal))
        {
            // only 1 page
            currentidx = vidtotal - 1;
            showThumbnail();
        }
        else 
        {
            // are there more pages?
            // currentpg is 1-based, currentidx is 0-based
            // var i = (currentpg - 1) * per_page + currentidx;  
            // if (i > 0)
            if (currentpg > 1)
            {
                // more before, go back a page
                currentpg -= 1;           
            }
            else 
            {
                // wrap around
                currentpg = Math.ceil(vidtotal / per_page);
                
            }
            requestVideoList(-1);
        }
    }    
    else 
    {
        showThumbnail();
    }
    divContent.filters[0].play();
}

function numberClickHandler()
{
    divVideoNumberPrompt.style.visibility = "visible";

    // divVideoNumberPrompt.onclick = function() { divVideoNumberPrompt.style.visibility = "hidden"; };
    // TextVideoNumberPrompt.onclick = "return false;";
    TextVideoNumberPrompt.onkeypress = numberEnterHandler;
    ImgButtonVideoNumberPromptClose.onclick = function() { divVideoNumberPrompt.style.visibility = "hidden"; };
    ButtonVideoNumberPromptGo.onclick = numberConfirmHandler;
}

function numberEnterHandler() 
{ 
    if (event.keyCode == 13) 
        numberConfirmHandler(); 
};

function numberConfirmHandler()
{
    
    divVideoNumberPrompt.style.visibility = "hidden"; 
    var dest = parseInt (TextVideoNumberPrompt.value);
    if ((dest > 0) && (dest <= vidtotal))
    {
        divContent.filters[3].apply();
        // express in 0-based
        // var vidtotal_dest = dest - 1;
        // is the destination in current vidarray range, expressed in vidtotal index
        var currentstart = (currentpg - 1) * per_page + 1;
        var currentend = (currentpg) * per_page;
        
        if ((dest >= currentstart) && (dest <= currentend))
        {
            currentidx = dest - currentstart;
            showThumbnail();
        }
        else
        {
            // find the right page to request
            currentpg = Math.floor((dest - 1) / per_page) + 1;
            var newindex = (dest - 1) % per_page;
            requestVideoList(newindex);
        // total pages = Math.ceil(vidtotal / per_page);
        }
        divContent.filters[3].play();
    }
}

function layerMousedownHandler()
{
    // divTitlebar.innerText = event.x + "," + event.y;
    // var x = divEmbedded.fireEvent('onmousedown',event);
    // divTitlebar.innerText = divTitlebar.innerText + ">>" + x;
    return true;
}

function detailsClickHandler()
{
    flyoutClickHandler("details_flyout.htm", updateDetailsFlyout, "divDetailsFlyout");
}

function zoomClickHandler()
{
    flyoutClickHandler("zoom_flyout.htm", showZoomFlyout, "divZoomFlyout");
    showThumbnail(true);
}

function flyoutClickHandler(flyout_file, flyout_show_callback, flyout_element_id)
{
    if (vidtotal == 0)
    {
        return;
    }
    if (System.Gadget.Flyout.show == true)
    {
        // set up next flyout if it's different than the current one
        if (System.Gadget.Flyout.document.getElementById(flyout_element_id) == null)
        {
            System.Gadget.Flyout.onhide = function() {
                    System.Gadget.Flyout.file = flyout_file;
                    System.Gadget.Flyout.onhide = function() { };
                    System.Gadget.Flyout.onshow = flyout_show_callback;
                    setTimeout(function() { System.Gadget.Flyout.show = true }, 500);
            }
            System.Gadget.Flyout.show = false;
        }
        
        else 
        {
            // refresh flyout content
            flyout_show_callback();
        }
        
    }
    else
    {
        System.Gadget.Flyout.file = flyout_file;
        System.Gadget.Flyout.onshow = flyout_show_callback;
        System.Gadget.Flyout.onhide = function() {};
        System.Gadget.Flyout.show = true;
    }
    /*
    if ((System.Gadget.Flyout.show != true) ||
            (System.Gadget.Flyout.document.getElementById(flyout_element_id) == null))
    {
        
        System.Gadget.Flyout.file = flyout_file;
        System.Gadget.Flyout.onshow = flyout_show_callback;
        System.Gadget.Flyout.show = true;
    }
    */
}


function updateDetailsFlyout()
{

    var months = ['', 'January', 'Febrary', 'March', 'April',
        'May', 'June', 'July', 'August', 
        'September', 'October', 'November', 'December'];
    var added_on = new Date();
    added_on.setTime(parseInt(vidarray[currentidx].upload_time) * 1000);
    System.Gadget.Flyout.document.getElementById("id1").innerText = vidarray[currentidx].title;
    System.Gadget.Flyout.document.getElementById("id2").innerText = vidarray[currentidx].rating_avg;    
    System.Gadget.Flyout.document.getElementById("id3").innerText = vidarray[currentidx].rating_count; 
    System.Gadget.Flyout.document.getElementById("id4").innerText = vidarray[currentidx].description;
    System.Gadget.Flyout.document.getElementById("id5").innerText = vidarray[currentidx].view_count;
    System.Gadget.Flyout.document.getElementById("id6").innerText = months[added_on.getMonth()] + ' ' + added_on.getDate() + ", " + added_on.getFullYear();
    System.Gadget.Flyout.document.getElementById("id7").innerText = vidarray[currentidx].comment_count;
    System.Gadget.Flyout.document.getElementById("id8").innerText = vidarray[currentidx].tags;
    // System.Gadget.Flyout.document.getElementById("id9").innerText = vidarray[currentidx].url;
    // System.Gadget.Flyout.document.getElementById("id10").innerText = vidarray[currentidx].thumbnail_url;
    System.Gadget.Flyout.document.getElementById("id11").innerText = vidarray[currentidx].author;
    System.Gadget.Flyout.document.getElementById("id12").innerText = convertSecondsToClock(vidarray[currentidx].length_seconds);;    
}

function showZoomFlyout()
{
    var v = vidarray[currentidx];
    var flyoutdoc = System.Gadget.Flyout.document;
    var width = parseInt(flyoutdoc.styleSheets[0].rules[1].style.width);
    var height = parseInt(flyoutdoc.styleSheets[0].rules[1].style.height);

    flyoutdoc.getElementById("divFlyoutContent").innerHTML = buildEmbedCode (width, height, 
            "http://www.youtube.com/v/" + v.id + "&autoplay=1&rel=0");
    flyoutdoc.getElementById("divFlyoutContent").onclick = "return false;"
    
    
    if (prefAutoplay == "on")
    {
        // stops the thumbnail timer, design limitation
        clearTimer();
        setAutostopTimer(parseInt(v.length_seconds)); 
    }     
}

function playEmbedInContent()
{
    // youtube embed dimension = 425,350, keep ratio the same
    // for best fit
    
    divLayer.style.visibility = "hidden";

    divContent.filters[2].apply();
       
    var width = parseInt(document.styleSheets[0].rules[2].style.width);
    var height = parseInt(document.styleSheets[0].rules[2].style.height);
    var v = vidarray[currentidx];

    divLayer.style.visibility = "hidden";

    divEmbedded.style.visibility = "visible";
    divEmbedded.innerHTML = buildEmbedCode (width, height, 
            "http://www.youtube.com/v/" + v.id + "&autoplay=1&rel=0");
    divEmbedded.onclick = "return false;";
    
    divContent.filters[2].play();
    
    clearTimer();
    if (prefAutoplay == "on")
        setAutostopTimer(parseInt(v.length_seconds));  
}

function clearTimer()
{
    if (tmr != null)
        clearTimeout(tmr);
}

function setAutostopTimer(t)
{
    if (tmr != null)
        clearTimeout(tmr);
    tmr = setTimeout(nextClickHandler, 
            1000 * (prefAutostopDelay + t));  
}

function buildEmbedCode(width, height, url)
{
    var embedcode = '<object width="' + width + 
        '" height="' + height + 
        '<param name="movie" value="' + url +
        '"></param><param name="wmode" value="transparent">' +
        '</param><param name="wmode" value="transparent"></param><embed src="' +
        url + '" type="application/x-shockwave-flash" wmode="transparent" width="' +
        width + '" height="' + height + '"></embed></object>';
    return embedcode;
}

function buttonHighlightOn()
{
    window.event.srcElement.className = "buttonHighlightOn";
    window.event.srcElement.onmouseout = function() { 
        window.event.srcElement.className = "buttonHighlightOff";
    }
}